<template>
    <div class="wrapper">

      <div class="header">
        <div
          :style="`background-image: url(${require('@/assets/img/arrow-back.svg')})`"
          @click="$emit('back')"
          class="arrow-back-button"
        >
        </div>
        Добавить карту
      </div>
      
      <div v-if="isTipOpen" class="tip">
        Введите данные карты, которую планируете использовать для оплаты
        <div @click="$emit('tipClosed')" :style="`background-image: url(${require('@/assets/img/cross.svg')})`" class="cross-icon">
        </div>
      </div>
      
      <div class="input-wrapper">
        <input
          class="input"
          type="tel"
          @input="cardID = $event.target.value"
          placeholder="Номер карты"
          v-mask="'#### #### #### ####'"
        />
      </div>

      <!-- <div class="input-wrapper">
        <input
          class="input"
          type="tel"
          placeholder="Срок действия"
          v-mask="'##/##'"
        />
      </div> -->

      <div class="input-wrapper">
        <input
          class="input"
          type="text"
          placeholder="Имя на карте"
          v-model="cardName"
          @input="cardNameValidation($event)"
        />
      </div>

      <!-- <div class="input-wrapper">
        <input
          class="input"
          type="tel"
          placeholder="CVV (CVC) код"
          v-mask="'###'"
        />
      </div> -->

      <div @click="mainButtonHandler($event)" class="save-button">Сохранить карту</div>

      <div @click="$emit('back')" class="cancel">Отменить</div>

    </div>
</template>

<script>
import { mask } from "vue-the-mask";
import {createRipple} from "@/utils/animations.js"

export default {
  directives: {
    mask,
  },
  data() {
    return {
      cardID: '', 
      cardName: ''
    }
  },
  props: {
    isTipOpen: Boolean,
  },
  methods: {
    createRipple,

    mainButtonHandler(event) {
      this.createRipple(event); 

      if (this.cardID.length === 19) {
        setTimeout(() => {

          const data = {
            card_id: (Math.random() * 1000000).toString(),
            card_mask: this.cardID.toString(),
            card_type: "VISA",
            issuer: "Kaspi Bank",
            name: this.cardName,
            is_main: true,
          }

          this.$store.dispatch('saveCard', { data })
        }, 200);
      }
      
    },

    cardNameValidation(e) {
      if (/[^ a-z'`~.-]/gi.test(e.target.value)) {
        e.target.value = e.target.value.replace(/[^ a-z'`~.-]/gi, '');
      }
    },
  }
}
</script>

<style scoped>
@import '../styles/styles.css';
</style>